package zinger.util.recycling;

import java.lang.reflect.Constructor;
import java.util.Collection;

public class CollectionGenerator extends ClassInstanceGenerator
{
    public CollectionGenerator(final Constructor constructor, final Object[] args) throws IllegalArgumentException
    {
        super(constructor, args);

        if(!Collection.class.isAssignableFrom(constructor.getDeclaringClass()))
        {
            throw new IllegalArgumentException("Must be an implementation of java.util.Collection.");
        }
    }

    public CollectionGenerator(final Class c) throws IllegalArgumentException
    {
        this(getDefaultConstructor(c), EMPTY_CLASS_ARRAY);
    }

    public boolean prepareObject(final Object obj, final Object arg) throws IllegalArgumentException
    {
        try
        {
            ((Collection)obj).clear();
            return true;
        }
        catch(final UnsupportedOperationException ex)
        {
            return false;
        }
    }
}