package zinger.util.recycling;

public class StringBufferGenerator implements ObjectGenerator
{
    protected final int length;

    public StringBufferGenerator(final int length)
    {
        this.length = length;
    }

    public StringBufferGenerator()
    {
        this(-1);
    }

    public Object newObject()
    {
        if(this.length >= 0)
        {
            return new StringBuffer(this.length);
        }
        else
        {
            return new StringBuffer();
        }
    }

    public boolean prepareObject(final Object obj, final Object arg) throws IllegalArgumentException
    {
        final StringBuffer sb;
        try
        {
            sb = (StringBuffer)obj;
        }
        catch(final ClassCastException ex)
        {
            return false;
        }
        sb.setLength(0);
        if(arg != null)
        {
            sb.append(arg);
        }
        return true;
    }
}