package zinger.util.recycling;

public class SynchronizedObjectPool implements ObjectPool
{
	protected final ObjectPool pool;

	public SynchronizedObjectPool(ObjectPool pool)
	{
		this.pool = pool;
	}

	public Object getObject() throws IllegalArgumentException
	{
		synchronized(this.pool)
		{
			return this.pool.getObject();
		}
	}

	public Object getObject(Object arg) throws IllegalArgumentException
	{
		synchronized(this.pool)
		{
			return this.pool.getObject(arg);
		}
	}

	public boolean recycleObject(Object obj)
	{
		synchronized(this.pool)
		{
			return this.pool.recycleObject(obj);
		}
	}

	public void clearCache()
	{
		synchronized(this.pool)
		{
			this.pool.clearCache();
		}
	}
}